package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.XM;

/**
 * 实体[HT] 数据对象
 */
@TableName(value = "T_HT",resultMap = "HTResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class HT extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private XM xm;
    private String cgfs;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    private String dfdw;
    @TableId(value= "htid",type=IdType.UUID)//指定主键生成策略
    private String htid;
    private String htname;
    private Double je;
    private String lxdh;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String xmid;
    @TableField(exist = false)//逻辑属性
    private Double xmje;
    @TableField(exist = false)//逻辑属性
    private String xmname;
    /**
     *  设置属性值[采购方式]
     *  @param cgfs
     */
    public void setCgfs(String cgfs){
        if(StringUtils.isEmpty(cgfs))
            cgfs=null;
        this.cgfs = cgfs;
        this.set("cgfsdirtyflag",true);
    }
    /**
     *  获取属性值[采购方式]
     */
    public String getCgfs(){
        return this.cgfs;
    }
    /**
     *  重置属性值[采购方式]
     */
    public void resetCgfs(){
        this.set("cgfsdirtyflag",false);
        this.cgfs = null;
    }
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[对方单位]
     *  @param dfdw
     */
    public void setDfdw(String dfdw){
        if(StringUtils.isEmpty(dfdw))
            dfdw=null;
        this.dfdw = dfdw;
        this.set("dfdwdirtyflag",true);
    }
    /**
     *  获取属性值[对方单位]
     */
    public String getDfdw(){
        return this.dfdw;
    }
    /**
     *  重置属性值[对方单位]
     */
    public void resetDfdw(){
        this.set("dfdwdirtyflag",false);
        this.dfdw = null;
    }
    /**
     *  设置属性值[合同标识]
     *  @param htid
     */
    public void setHtid(String htid){
        if(StringUtils.isEmpty(htid))
            htid=null;
        this.htid = htid;
        this.set("htiddirtyflag",true);
    }
    /**
     *  获取属性值[合同标识]
     */
    public String getHtid(){
        return this.htid;
    }
    /**
     *  重置属性值[合同标识]
     */
    public void resetHtid(){
        this.set("htiddirtyflag",false);
        this.htid = null;
    }
    /**
     *  设置属性值[合同名称]
     *  @param htname
     */
    public void setHtname(String htname){
        if(StringUtils.isEmpty(htname))
            htname=null;
        this.htname = htname;
        this.set("htnamedirtyflag",true);
    }
    /**
     *  获取属性值[合同名称]
     */
    public String getHtname(){
        return this.htname;
    }
    /**
     *  重置属性值[合同名称]
     */
    public void resetHtname(){
        this.set("htnamedirtyflag",false);
        this.htname = null;
    }
    /**
     *  设置属性值[金额]
     *  @param je
     */
    public void setJe(Double je){
        this.je = je;
        this.set("jedirtyflag",true);
    }
    /**
     *  获取属性值[金额]
     */
    public Double getJe(){
        return this.je;
    }
    /**
     *  重置属性值[金额]
     */
    public void resetJe(){
        this.set("jedirtyflag",false);
        this.je = null;
    }
    /**
     *  设置属性值[联系电话]
     *  @param lxdh
     */
    public void setLxdh(String lxdh){
        if(StringUtils.isEmpty(lxdh))
            lxdh=null;
        this.lxdh = lxdh;
        this.set("lxdhdirtyflag",true);
    }
    /**
     *  获取属性值[联系电话]
     */
    public String getLxdh(){
        return this.lxdh;
    }
    /**
     *  重置属性值[联系电话]
     */
    public void resetLxdh(){
        this.set("lxdhdirtyflag",false);
        this.lxdh = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[项目标识]
     *  @param xmid
     */
    public void setXmid(String xmid){
        if(StringUtils.isEmpty(xmid))
            xmid=null;
        this.xmid = xmid;
        this.set("xmiddirtyflag",true);
    }
    /**
     *  获取属性值[项目标识]
     */
    public String getXmid(){
        return this.xmid;
    }
    /**
     *  重置属性值[项目标识]
     */
    public void resetXmid(){
        this.set("xmiddirtyflag",false);
        this.xmid = null;
    }
    /**
     *  设置属性值[项目金额]
     *  @param xmje
     */
    public void setXmje(Double xmje){
        this.xmje = xmje;
        this.set("xmjedirtyflag",true);
    }
    /**
     *  获取属性值[项目金额]
     */
    public Double getXmje(){
        return this.xmje;
    }
    /**
     *  重置属性值[项目金额]
     */
    public void resetXmje(){
        this.set("xmjedirtyflag",false);
        this.xmje = null;
    }
    /**
     *  设置属性值[项目名称]
     *  @param xmname
     */
    public void setXmname(String xmname){
        if(StringUtils.isEmpty(xmname))
            xmname=null;
        this.xmname = xmname;
        this.set("xmnamedirtyflag",true);
    }
    /**
     *  获取属性值[项目名称]
     */
    public String getXmname(){
        return this.xmname;
    }
    /**
     *  重置属性值[项目名称]
     */
    public void resetXmname(){
        this.set("xmnamedirtyflag",false);
        this.xmname = null;
    }
     /**
     *  获取主实体关联数据[XM]
     */
    public XM getXm() {
        return xm;
    }
    /**
     *  设置主实体关联数据[XM]
     */
    public void setXm(XM xm) {
        this.xm = xm;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCgfs();
        resetCreatedate();
        resetCreateman();
        resetDfdw();
        resetHtid();
        resetHtname();
        resetJe();
        resetLxdh();
        resetUpdatedate();
        resetUpdateman();
        resetXmid();
        resetXmje();
        resetXmname();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public HT copyTo(HT targetEntity)
	{
		BeanCopier copier=BeanCopier.create(HT.class, HT.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetHtid();
		return targetEntity;
	}
}